/*
*    sfall
*    Copyright (C) 2008, 2009, 2010, 2013, 2014  The sfall team
*
*    This program is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "main.h"

#include "Logging.h"

static const DWORD obj_set_light_ = 0x48AC90; // <eax>(int aObj<eax>, signed int aDist<edx>, int a3<ecx>, int aIntensity<ebx>)
static const DWORD ranged_attack_lighting_fix_back = 0x4118F8;
static const DWORD tile_refresh_rect_ = 0x4B12C0; // (int elevation<edx>, unkown<ecx>)
static void __declspec(naked) ranged_attack_lighting_fix() {
	__asm {
		mov     eax, [esp+40]; // projectile ptr - 1st arg
		mov		ecx, [esp+1Ch]; // protoPtr of projectile
		mov     edx, [ecx+0x0C]; // light radius - 2nd arg
		mov     ebx, [ecx+0x10]; // light intensity - 4th arg
		//mov     ebx, 0x10000; // light intensity - 4th arg
		xor     ecx, ecx; // unknown(0) - 3rd argument
		call    obj_set_light_;
		jmp     ranged_attack_lighting_fix_back; // jump back
	}
}

static const DWORD register_object_light_=0x415334; // <eax>(int aObj<eax>, int aRadius<ebx>, char aUnknw<dil>)
static const DWORD explosion_lighting_fix1_back = 0x411A4C;
static void __declspec(naked) explosion_lighting_fix1() {
	__asm {
		mov     eax, [esp+40]; // projectile ptr - 1st arg
		mov		ebx, 8; // maximum radius
		//mov     edi, 0x00; // unknown(0) - 3rd argument
		call    register_object_light_;

		mov     ebx, 0FFFFFFFFh; // restore overwritten code
		jmp     explosion_lighting_fix1_back; // jump back
	}
}

static const DWORD explosion_lighting_fix2_back = 0x411AE7;
static void __declspec(naked) explosion_lighting_fix2() {
	__asm {
		mov     eax, [esp+esi]; // explosion obj ptr - 1st arg
		mov     edx, 8; // light radius - 2nd arg
		mov     ebx, 0x10000; // light intensity - 4th arg
		xor     ecx, ecx; // unknown(0) - 3rd argument
		call    obj_set_light_;

		// restore overwritten code:
		mov		ebx, 1;
		mov     eax, [esp+48h];
		mov     edx, edi;		
		jmp     explosion_lighting_fix2_back; // jump back
	}
}

static const DWORD explosion_lighting_fix3_back = 0x412DE6;
static void __declspec(naked) explosion_lighting_fix3() {
	__asm {
		mov     eax, [esp+ecx]; // explosion obj ptr - 1st arg
		mov     edx, 8; // light radius - 2nd arg
		mov     ebx, 0x10000; // light intensity - 4th arg
		push	ecx;
		mov		ecx, 0;
		call    obj_set_light_;
		pop ecx;
		

		// restore overwritten code:
		mov     eax, [esp+ecx];
		xor     edx, edx;
		jmp     explosion_lighting_fix3_back; // jump back
	}
}

/*
static const DWORD register_object_animate_and_hide_fix_back = 0x412DE6;
static void __declspec(naked) register_object_animate_and_hide_fix() {
	__asm {
		mov     eax, [esp+ecx]; // explosion obj ptr - 1st arg
		mov     edx, 8; // light radius - 2nd arg
		mov     ebx, 0x10000; // light intensity - 4th arg
		push	ecx;
		mov		ecx, 0;
		call    obj_set_light_;
		pop ecx;
		

		// restore overwritten code:
		mov     eax, [esp+ecx];
		xor     edx, edx;
		jmp     register_object_animate_and_hide_fix_back; // jump back
	}
}

mov		eax, [esp+ecx]; // explosion obj
		mov		edx, [eax+40]; // obj elevation
		call	tile_refresh_rect_;
		*/

void ExplosionLightingInit() {
	if (GetPrivateProfileIntA("Misc", "ExplosionsEmitLight", 0, ini)) {
		dlog("Initing Explosion changes.", DL_INIT);
		//MakeCall(0x411AB9, (void*)0x411B92, true); // skip while loop for additional explosion effects

		MakeCall(0x4118E1, &ranged_attack_lighting_fix, true);
		MakeCall(0x411A47, &explosion_lighting_fix1, true);
		MakeCall(0x411AE1, &explosion_lighting_fix2, true);
		SafeWrite8(0x411AE6, 0x90);
		MakeCall(0x412DE1, &explosion_lighting_fix3, true);
		dlogr(" Done", DL_INIT);
	}
}