/*
 *    sfall
 *    Copyright (C) 2008, 2009, 2010  The sfall team
 *
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include <hash_map>
#include "vector9x.cpp"

struct sGlobalVar {
	__int64 id;
	int val;
};

struct sArrayVar {
	DWORD len;
	DWORD datalen;
	DWORD* types;
	char* data;
};

void ScriptExtenderSetup();
void LoadGlobalScripts();
void ClearCheckedScripts();

void RunGlobalScripts1();
void RunGlobalScripts2();
void RunGlobalScripts3();

void LoadGlobals(HANDLE h);
void LoadArrays(HANDLE h);
void SaveGlobals(HANDLE h);
void SaveArrays(HANDLE h);
void ClearGlobals();

int GetNumGlobals();
void GetGlobals(sGlobalVar* globals);
void SetGlobals(sGlobalVar* globals);
int GetNumArrays();
void GetArrays(int* arrays);

void DEGetArray(int id, DWORD* types, void* data);
void DESetArray(int id, const DWORD* types, const void* data);

extern DWORD AddUnarmedStatToGetYear;
extern DWORD AvailableGlobalScriptTypes;

void SetAppearanceGlobals(int race, int style);
void GetAppearanceGlobals(int *race, int *style);

DWORD _stdcall ScriptHasLoaded(DWORD script);

// for script functions
static const DWORD GetArgType=0x4674F0;
static const DWORD GetArg=0x467500;
static const DWORD GetStringVar=0x4678E0; //eax = script ptr, edx = var type, ebx = var
static const DWORD CreateStringVar=0x467A80; //edx = ptr to string, eax = script
static const DWORD SetResult=0x4674DC;
static const DWORD SetResultType=0x46748C;

// types for script variables
#define VAR_TYPE_INT	(0xC001)
#define VAR_TYPE_FLOAT	(0xA001)
#define VAR_TYPE_STR	(0x9801)
#define VAR_TYPE_STR2	(0x9001)

#define DATATYPE_NONE  (0)
#define DATATYPE_INT   (1)
#define DATATYPE_FLOAT (2)
#define DATATYPE_STR   (3)