/*
 *    sfall
 *    Copyright (C) 2008, 2009, 2010, 2011, 2012  The sfall team
 *
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "main.h"

#include "ScriptExtender.h"
#include "ScriptArrays.hpp"
#include "FileSystem.h"

extern stdext::hash_map<DWORD, sArrayVar> arrays;
extern DWORD nextarrayid;
extern vector<DWORD> tempArrays;

static void __declspec(naked) funcSqrt() {
	__asm {
		pushad;
		sub esp, 4;
		mov ecx, eax;
		call GetArgType;
		mov ebx, eax;
		mov eax, ecx;
		call GetArg;
		cmp bx, 0xc001;
		jnz arg1l2;
		mov [esp], eax;
		fild [esp];
		jmp calc;
arg1l2:
		cmp bx, 0xa001;
		jnz fail;
		mov [esp], eax;
		fld [esp];
calc:
		fsqrt;
		fstp [esp];
		mov edx, [esp];
		jmp end;
fail:
		fldz;
		fstp [esp];
		mov edx, [esp];
end:
		mov eax, ecx;
		call SetResult;
		mov edx, 0xa001;
		mov eax, ecx;
		call SetResultType;
		add esp, 4;
		popad;
		retn;
	}
}
static void __declspec(naked) funcAbs() {
	__asm {
		pushad;
		sub esp, 4;
		mov ecx, eax;
		call GetArgType;
		mov ebx, eax;
		mov eax, ecx;
		call GetArg;
		cmp bx, 0xc001;
		jnz arg1l2;
		mov [esp], eax;
		fild [esp];
		jmp calc;
arg1l2:
		cmp bx, 0xa001;
		jnz fail;
		mov [esp], eax;
		fld [esp];
calc:
		fabs;
		fstp [esp];
		mov edx, [esp];
		jmp end;
fail:
		fldz;
		fstp [esp];
		mov edx, [esp];
end:
		mov eax, ecx;
		call SetResult;
		mov edx, 0xa001;
		mov eax, ecx;
		call SetResultType;
		add esp, 4;
		popad;
		retn;
	}
}
static void __declspec(naked) funcSin() {
	__asm {
		pushad;
		sub esp, 4;
		mov ecx, eax;
		call GetArgType;
		mov ebx, eax;
		mov eax, ecx;
		call GetArg;
		cmp bx, 0xc001;
		jnz arg1l2;
		mov [esp], eax;
		fild [esp];
		jmp calc;
arg1l2:
		cmp bx, 0xa001;
		jnz fail;
		mov [esp], eax;
		fld [esp];
calc:
		fsin;
		fstp [esp];
		mov edx, [esp];
		jmp end;
fail:
		fldz;
		fstp [esp];
		mov edx, [esp];
end:
		mov eax, ecx;
		call SetResult;
		mov edx, 0xa001;
		mov eax, ecx;
		call SetResultType;
		add esp, 4;
		popad;
		retn;
	}
}
static void __declspec(naked) funcCos() {
	__asm {
		pushad;
		sub esp, 4;
		mov ecx, eax;
		call GetArgType;
		mov ebx, eax;
		mov eax, ecx;
		call GetArg;
		cmp bx, 0xc001;
		jnz arg1l2;
		mov [esp], eax;
		fild [esp];
		jmp calc;
arg1l2:
		cmp bx, 0xa001;
		jnz fail;
		mov [esp], eax;
		fld [esp];
calc:
		fcos;
		fstp [esp];
		mov edx, [esp];
		jmp end;
fail:
		fldz;
		fstp [esp];
		mov edx, [esp];
end:
		mov eax, ecx;
		call SetResult;
		mov edx, 0xa001;
		mov eax, ecx;
		call SetResultType;
		add esp, 4;
		popad;
		retn;
	}
}
static void __declspec(naked) funcTan() {
	__asm {
		pushad;
		sub esp, 4;
		mov ecx, eax;
		call GetArgType;
		mov ebx, eax;
		mov eax, ecx;
		call GetArg;
		cmp bx, 0xc001;
		jnz arg1l2;
		mov [esp], eax;
		fild [esp];
		jmp calc;
arg1l2:
		cmp bx, 0xa001;
		jnz fail;
		mov [esp], eax;
		fld [esp];
calc:
		fptan;
		fstp [esp];
		fstp [esp];
		mov edx, [esp];
		jmp end;
fail:
		fldz;
		fstp [esp];
		mov edx, [esp];
end:
		mov eax, ecx;
		call SetResult;
		mov edx, 0xa001;
		mov eax, ecx;
		call SetResultType;
		add esp, 4;
		popad;
		retn;
	}
}
static void __declspec(naked) funcATan() {
	__asm {
		pushad;
		sub esp, 4;
		mov ecx, eax;
		call GetArgType;
		mov ebx, eax;
		mov eax, ecx;
		call GetArg;
		mov edi, eax;
		mov eax, ecx;
		call GetArgType;
		mov edx, eax;
		mov eax, ecx;
		call GetArg;
		cmp bx, 0xc001;
		jnz arg1l2;
		mov [esp], eax;
		fild [esp];
		jmp arg2l1;
arg1l2:
		cmp bx, 0xa001;
		jnz fail;
		mov [esp], eax;
		fld [esp];
arg2l1:
		cmp dx, 0xc001;
		jnz arg2l2;
		mov [esp], edi;
		fild [esp];
		jmp calc;
arg2l2:
		cmp dx, 0xa001;
		jnz fail2;
		mov [esp], edi;
		fld [esp];
calc:
		fpatan;
		fstp [esp];
		mov edx, [esp];
		jmp end;
fail2:
		fstp [esp];
fail:
		fldz;
		fstp [esp];
		mov edx, [esp];
end:
		mov eax, ecx;
		call SetResult;
		mov edx, 0xa001;
		mov eax, ecx;
		call SetResultType;
		add esp, 4;
		popad;
		retn;
	}
}

static int _stdcall StringSplit(const char* str, const char* split) {
	int id;
	if(strlen(split)==0) {
		id=TempArray(strlen(str), 4);
		for(DWORD i=0;i<strlen(str);i++) {
			arrays[id].types[i]=DATATYPE_STR;
			arrays[id].data[i*4]=str[i];
		}
	} else {
		int count=1;
		const char *ptr=str, *newptr;
		DWORD maxlen=4;
		while(true) {
			newptr=strstr(ptr, split);
			if(!newptr) {
				maxlen=max(maxlen, strlen(ptr));
				break;
			}
			count++;
			maxlen=max(maxlen, (DWORD)(newptr-ptr)+1);
			ptr=newptr+strlen(split);
		}
		id=TempArray(count, maxlen+1);
		for(int i=0;i<count;i++) arrays[id].types[i]=DATATYPE_STR;
		ptr=str;
		count =0;
		while(true) {
			newptr=strstr(ptr, split);
			int len=newptr?newptr-ptr:strlen(ptr);
			strncpy(&arrays[id].data[count++*arrays[id].datalen], ptr, len);
			if(!newptr) break;
			ptr=newptr+strlen(split);
		}
	}
	return id;
}
static void __declspec(naked) string_split() {
	__asm {
		pushad;
		mov ebp, eax;
		call GetArgType;
		mov ebx, eax;
		mov eax, ebp;
		call GetArg;
		mov edi, eax;
		mov eax, ebp;
		call GetArgType;
		mov ecx, eax;
		mov eax, ebp;
		call GetArg;
		mov esi, eax;
		cmp bx, 0x9001;
		jz str1;
		cmp bx, 0x9801;
		jnz fail;
str1:
		cmp cx, 0x9001;
		jz str2;
		cmp cx, 0x9801;
		jnz fail;
str2:
		mov eax, ebp;
		mov edx, ebx;
		mov ebx, edi;
		call GetStringVar;
		mov edi, eax;
		mov eax, ebp;
		mov edx, ecx;
		mov ebx, esi;
		call GetStringVar;
		push edi;
		push eax;
		call StringSplit;
		mov edx, eax;
		jmp end;
fail:
		xor edx, edx;
end:
		mov eax, ebp;
		call SetResult;
		mov edx, 0xc001;
		mov eax, ebp;
		call SetResultType;
		popad;
		retn;
	}
}
static int _stdcall str_to_int_internal(const char* str) {
	return (int)strtol(str, (char**)NULL, 0); // auto-determine radix
}
static DWORD _stdcall str_to_flt_internal(const char* str) {
	float f=(float)atof(str);
	return *(DWORD*)&f;
}
static void __declspec(naked) str_to_int() {
	__asm {
		pushad;
		mov ebp, eax;
		call GetArgType;
		mov ebx, eax;
		mov eax, ebp;
		call GetArg;
		cmp bx, 0x9001;
		jz str1;
		cmp bx, 0x9801;
		jnz fail;
str1:
		mov edx, ebx;
		mov ebx, eax;
		mov eax, ebp;
		call GetStringVar;
		push eax;
		call str_to_int_internal;
		mov edx, eax;
		jmp end;
fail:
		xor edx, edx;
end:
		mov eax, ebp;
		call SetResult;
		mov edx, 0xc001;
		mov eax, ebp;
		call SetResultType;
		popad;
		retn;
	}
}
static void __declspec(naked) str_to_flt() {
	__asm {
		pushad;
		mov ebp, eax;
		call GetArgType;
		mov ebx, eax;
		mov eax, ebp;
		call GetArg;
		cmp bx, 0x9001;
		jz str1;
		cmp bx, 0x9801;
		jnz fail;
str1:
		mov edx, ebx;
		mov ebx, eax;
		mov eax, ebp;
		call GetStringVar;
		push eax;
		call str_to_flt_internal;
		mov edx, eax;
		jmp end;
fail:
		xor edx, edx;
end:
		mov eax, ebp;
		call SetResult;
		mov edx, 0xa001;
		mov eax, ebp;
		call SetResultType;
		popad;
		retn;
	}
}
static char* _stdcall mysubstr(char* str, int pos, int length) {
	char* newstr;
	int srclen;
	srclen = strlen(str);
	if (pos < 0)
		pos = srclen + pos;
	if (length < 0)
		length = srclen - pos + length;
	if (pos >= srclen)
		length = 0;
	else if (length+pos > srclen) 
		length = srclen-pos;
	newstr = new char[length+1];
	if (length > 0)
		memcpy(newstr, &str[pos], length);
	newstr[length] = '\0';
	return newstr;
}

static DWORD _stdcall mystrlen(char* str) {
	return strlen(str);
}

static char* _stdcall mysprintf(char* format, DWORD value, DWORD valueType) {
	valueType = valueType & 0xFFFF; // use lower 2 bytes
	int buflen = strlen(format);
	// parse format to make it safe
	char* newfmt = new char[buflen];
	byte mode = 0;
	int j=0;
	char c, specifier;
	bool hasDigits = false;
	for (int i=0; i<buflen; i++) {
		c = format[i];
		switch (mode) {
		case 0: // prefix
			if (c == '%') {
				mode = 1;
			}
			break;
		case 1: // definition
			if ((c >= 'a' && c <= 'z') || (c >= 'A' && c <= 'Z')) {
				if (c == 'h' || c == 'l' || c == 'j' || c == 'z' || c == 't' || c == 'L')  // ignore sub-specifiers
					continue;
				if (c == 's' && valueType != VAR_TYPE_STR2 && valueType != VAR_TYPE_STR) // don't allow to treat non-string values as string pointers
					c = 'd';
				else if (c == 'n') // don't allow "n" specifier
					c = 'd';
				specifier = c;
				mode = 2;
			} else if (c == '%') {
				mode = 0;
				hasDigits = false;
			} else if (c >= '0' && c <= '9') {
				hasDigits = true;
			}
			break;
		case 2: // postfix
		default:
			if (c == '%') // don't allow more than one specifier
				newfmt[j++] = '%'; // just escape it
			break;
		}
		newfmt[j++] = c;
	}
	newfmt[j] = '\0';
	// calculate required memory
	if (hasDigits) {
		buflen = 254;
	} else if (specifier == 'c') {
		buflen = j;
	} else if (specifier == 's') {
		buflen = j + strlen((char*)value);
	} else {
		buflen = j + 30; // numbers
	}
	char* buf = new char[buflen+1];
	if (valueType == VAR_TYPE_FLOAT) {
		_snprintf(buf, buflen, newfmt, *(float*)(&value));
	} else {
		_snprintf(buf, buflen, newfmt, value);
	}
	buf[buflen] = '\0'; // just in case
	delete newfmt;
	return buf;
}

static void __declspec(naked) op_substr() {
	__asm {
		pushad;
		mov edi, eax;
		call GetArgType;
		push eax;
		mov eax, edi;
		call GetArg; // length
		push eax;
		mov eax, edi;
		call GetArgType;
		push eax;
		mov eax, edi;
		call GetArg; // position
		push eax;
		mov eax, edi;
		call GetArgType;
		push eax;
		mov eax, edi;
		call GetArg; // string
		push eax;

		movzx eax, word ptr [esp+12];
		cmp eax, VAR_TYPE_INT;
		jne fail;
		movzx eax, word ptr [esp+20];
		cmp eax, VAR_TYPE_INT;
		jne fail;
		movzx eax, word ptr [esp+4];
		cmp eax, VAR_TYPE_STR2;
		je next1;
		cmp eax, VAR_TYPE_STR;
		jne fail;
next1:
		mov eax, edi;
		mov edx, [esp+4];
		mov ebx, [esp];
		call GetStringVar;
		mov ebx, [esp+16];
		mov edx, [esp+8];
		push ebx;
		push edx;
		push eax;
		call mysubstr;
		mov edx, eax;
		mov eax, edi;
		call CreateStringVar;
		mov edx, eax;
		mov eax, edi;
		call SetResult;
		mov edx, VAR_TYPE_STR;
		mov eax, edi;
		call SetResultType;
		jmp end;
fail:
		xor edx, edx;
		mov eax, edi;
		call SetResult;
		mov edx, VAR_TYPE_INT;
		mov eax, edi;
		call SetResultType;
end:
		add esp, 24;
		popad;
		retn;
	}
}

static void __declspec(naked) op_strlen() {
	__asm {
		pushad;
		mov edi, eax;
		call GetArgType;
		mov edx, eax;
		mov eax, edi;
		call GetArg; // string
		cmp dx, VAR_TYPE_STR2;
		je next;
		cmp dx, VAR_TYPE_STR;
		jne fail;
next:
		mov ebx, eax;
		mov eax, edi;
		call GetStringVar;
		push eax;
		call mystrlen;
		jmp end;
fail:
		xor eax, eax; // return 0
end:
		mov edx, eax;
		mov eax, edi;
		call SetResult;
		mov edx, VAR_TYPE_INT;
		mov eax, edi;
		call SetResultType;
		popad;
		retn;
	}
}

static void __declspec(naked) op_sprintf() {
	__asm {
		pushad;
		mov edi, eax;
		call GetArgType;
		mov edx, eax;
		mov eax, edi;
		call GetArg; // any value
		mov ebx, eax;
		mov eax, edi;

		call GetArgType;
		mov ecx, eax;
		mov eax, edi;
		call GetArg; // format string
		mov esi, eax;
		// check types
		cmp cx, 0x9001;
		je nextarg;
		cmp cx, VAR_TYPE_STR;
		jne fail;
nextarg:
		cmp dx, 0x9001;
		je next2;
		cmp dx, VAR_TYPE_STR;
		jne notstring;
next2:
		mov eax, edi;
		call GetStringVar; // value string ptr
		mov ebx, eax;
notstring:
		push edx; // arg 3 - valueType
		mov eax, esi;
		mov esi, ebx;
		mov edx, ecx;
		mov ebx, eax;
		mov eax, edi;
		call GetStringVar; // format string ptr
		push esi; // arg 2 - value
		push eax; // arg 1 - format str
		call mysprintf;
		mov edx, eax;
		mov eax, edi;
		call CreateStringVar;
		mov edx, eax;
		mov eax, edi;
		call SetResult;
		mov edx, VAR_TYPE_STR;
		mov eax, edi;
		call SetResultType;
fail:
		popad;
		retn;
	}
}

static DWORD _stdcall GetValueType(DWORD datatype) {
	datatype&=0xffff;
	switch(datatype) {
	case VAR_TYPE_STR:
	case VAR_TYPE_STR2:
		return DATATYPE_STR;
	case VAR_TYPE_INT:
		return DATATYPE_INT;
	case VAR_TYPE_FLOAT:
		return DATATYPE_FLOAT;
	default:
		return DATATYPE_NONE; // just in case
	}
}

static void __declspec(naked) op_typeof() {
	__asm {
		pushad;
		mov edi, eax;
		call GetArgType;
		mov edx, eax;
		mov eax, edi;
		call GetArg; // call just in case (not used)
		push edx;
		call GetValueType;
		mov edx, eax;
		mov eax, edi;
		call SetResult;
		mov edx, VAR_TYPE_INT;
		mov eax, edi;
		call SetResultType;
		popad;
		retn;
	}
}